var BMPTTooltip = {
  onPopupShowing: function BMPTT_onPopupShowing(event){
    this.previewNode.src = null;
    this.previewNode.removeAttribute("style");
    this.previewNode.collapsed = true;  
    return BookmarksEventHandler.fillInBTTooltip(document.tooltipNode);
  },
  enabled: false,
  _previewNode : null,
  get previewNode(){
    if (!this._previewNode)
      this._previewNode = document.getElementById("bmptt_image");
    return this._previewNode;
  },
  _prefs : null,
  get prefs(){
    if (!this._prefs){
      this._prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
      this._prefs = this._prefs.getBranch("extensions.bookmarkpreviews.");
    }
    return this._prefs;
  },
  load: function BMPTT_load(event){
    BMPTTooltip.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2).addObserver("",BMPTTooltip,false);
    BMPTTooltip.enabled = BMPTTooltip.prefs.getBoolPref("toolbarTooltips");
  },
  unload: function BMPTT_unload(event){
    BMPTTooltip.prefs.removeObserver("",BMPTTooltip,false);
    BMPTTooltip.disableTooltip();
  },
  observe: function BMPTT_observe(subject, topic, data){
    if (topic != "nsPref:changed"){
      return;
    }
    if (data == "toolbarTooltips"){
      BMPTTooltip.enabled = this.prefs.getBoolPref("toolbarTooltips");
    }
  },
  tooltipShown: function BMPTT_tooltipshown(event){
    if (!this.enabled)
      return;
    var tooltip = event.target;
    var title = {}, url = {};
    url.value = document.getElementById("btUrlText").value; 
    
    var src = this.getImage(url.value);
    if (src){
      var image = new Image();
      image.onload = function(event){
        var target = BMPTTooltip.previewNode;
        var maxwidth = 300;
        var width = image.width;
        var height = image.height;
        if (width>maxwidth){
          height = maxwidth / width * height;
          target.setAttribute("style","max-width: "+maxwidth+"px; max-height: "+height+"px");
          target.src = src;
        }
      };
      image.src = src;
      if (image.complete) image.onload();
      this.previewNode.collapsed = false;
    } else{
      this.previewNode.collapsed = true;
    }
  },
  getImage: function BMPTT_getimage(url){
    if (url){
      var file = PreviewServiceUtils.getPreviewFile(url);
      if (file.exists() && file.isFile()){
        var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var uri = ios.newFileURI(file);
        if (uri)
          return uri.spec;
      }
    }
    return null;
  }
}
addEventListener("load",BMPTTooltip.load,false);
addEventListener("unload",BMPTTooltip.unload,false);